diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/media/MediaElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/media/MediaElement.java
index 7305bf9d2..1d49eae84 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/media/MediaElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/media/MediaElement.java
@@ -6,20 +6,20 @@ package eu.etaxonomy.taxeditor.ui.section.media;
 import org.eclipse.swt.events.SelectionListener;
 
 import eu.etaxonomy.cdm.hibernate.HibernateProxyHelper;
+import eu.etaxonomy.cdm.model.agent.AgentBase;
 import eu.etaxonomy.cdm.model.agent.TeamOrPersonBase;
 import eu.etaxonomy.cdm.model.common.LanguageString;
 import eu.etaxonomy.cdm.model.media.Media;
 import eu.etaxonomy.taxeditor.store.CdmStore;
 import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
-import eu.etaxonomy.taxeditor.ui.element.CdmPropertyChangeEvent;
+import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.EntityDetailType;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.LanguageStringWithLabelElement;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.EntityDetailType;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.SelectionType;
+import eu.etaxonomy.taxeditor.ui.element.LayoutConstants;
 import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection;
 import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement;
-import eu.etaxonomy.taxeditor.ui.selection.AgentSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 
 /**
  * <p>
@@ -33,7 +33,7 @@ import eu.etaxonomy.taxeditor.ui.selection.AgentSelectionElement;
 public class MediaElement extends AbstractEntityCollectionElement<Media> {
 
 	private MediaRepresentationSection section_mediaRepresentation;
-	private AgentSelectionElement selection_artist;
+	private EntitySelectionElement<AgentBase> selection_artist;
 	private LanguageStringWithLabelElement text_description;
 	private LanguageStringWithLabelElement text_title;
 
@@ -73,17 +73,17 @@ public class MediaElement extends AbstractEntityCollectionElement<Media> {
 	public void createControls(ICdmFormElement element, int style) {
 		text_title = formFactory.createLanguageStringWithLabelElement(element,
 				"Title", null, style);
-		selection_artist = (AgentSelectionElement) formFactory
-				.createSelectionElement(SelectionType.AGENT,
+		selection_artist = formFactory
+				.createSelectionElement(AgentBase.class,
 						getConversationHolder(), element, "Artist", null,
-						AgentSelectionElement.DEFAULT, style);
+						EntitySelectionElement.ALL, style);
 		text_description = formFactory.createLanguageStringWithLabelElement(
 				element, "Description", null, 100, style);
 		section_mediaRepresentation = (MediaRepresentationSection) formFactory
 				.createEntityDetailSection(
 						EntityDetailType.MEDIAREPRESENTATION,
 						getConversationHolder(), element, style);
-		section_mediaRepresentation.setLayoutData(CdmFormFactory
+		section_mediaRepresentation.setLayoutData(LayoutConstants
 				.FILL_HORIZONTALLY(2, 1));
 	}
 
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/media/MediaRepresentationElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/media/MediaRepresentationElement.java
index ec3f03aee..0bff02bf3 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/media/MediaRepresentationElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/media/MediaRepresentationElement.java
@@ -24,9 +24,10 @@ import eu.etaxonomy.cdm.model.media.MediaRepresentationPart;
 import eu.etaxonomy.taxeditor.store.StoreUtil;
 import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
+import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.EntityDetailType;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
+import eu.etaxonomy.taxeditor.ui.element.LayoutConstants;
 import eu.etaxonomy.taxeditor.ui.element.TextWithLabelElement;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.EntityDetailType;
 import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement;
 
 /**
@@ -67,7 +68,7 @@ public class MediaRepresentationElement extends AbstractEntityCollectionElement<
 		text_mimeType = formFactory.createTextWithLabelElement(element, "Mime Type", null, style);
 		text_suffix = formFactory.createTextWithLabelElement(element, "Suffix", null, style);
 		section_mediaRepresentationPart = (MediaRepresentationPartSection) formFactory.createEntityDetailSection(EntityDetailType.MEDIAREPRESENTATIONPART, getConversationHolder(), element, style);
-		section_mediaRepresentationPart.setLayoutData(CdmFormFactory.FILL_HORIZONTALLY(2, 1));
+		section_mediaRepresentationPart.setLayoutData(LayoutConstants.FILL_HORIZONTALLY(2, 1));
 	}
 
 	/** {@inheritDoc} */
@@ -125,11 +126,5 @@ public class MediaRepresentationElement extends AbstractEntityCollectionElement<
 				StoreUtil.error(getClass(), e);
 			}
 		}
-		
-		
-	}
-	
-	private String getMimeType(URI uri){
-		return null;
 	}
 }
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/AbstractTypeDesignationElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/AbstractTypeDesignationElement.java
index 6c03a53ad..99506c563 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/AbstractTypeDesignationElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/AbstractTypeDesignationElement.java
@@ -10,7 +10,6 @@
 
 package eu.etaxonomy.taxeditor.ui.section.name;
 
-import org.apache.log4j.Logger;
 import org.eclipse.swt.events.SelectionListener;
 
 import eu.etaxonomy.cdm.model.name.TypeDesignationBase;
@@ -29,8 +28,6 @@ import eu.etaxonomy.taxeditor.ui.section.supplemental.AbstractReferencedEntityEl
  */
 public abstract class AbstractTypeDesignationElement<T extends TypeDesignationBase> extends AbstractReferencedEntityElement<T> {
 
-	private static final Logger logger = Logger
-			.getLogger(AbstractTypeDesignationElement.class);
 	protected CheckboxElement checkbox_notDesignated;
 	
 
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/AuthorshipDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/AuthorshipDetailElement.java
index 873ff4cc6..aa03fae0b 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/AuthorshipDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/AuthorshipDetailElement.java
@@ -13,16 +13,15 @@ package eu.etaxonomy.taxeditor.ui.section.name;
 import java.util.Arrays;
 
 import eu.etaxonomy.cdm.model.agent.INomenclaturalAuthor;
+import eu.etaxonomy.cdm.model.agent.Team;
 import eu.etaxonomy.cdm.model.name.NonViralName;
 import eu.etaxonomy.taxeditor.model.AuthorHelper;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.CdmPropertyChangeEvent;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.IEnableableFormElement;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.SelectionType;
-import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection;
 import eu.etaxonomy.taxeditor.ui.section.AbstractIdentifiableEntityDetailElement;
-import eu.etaxonomy.taxeditor.ui.selection.AbstractSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 import eu.etaxonomy.taxeditor.ui.selection.NomenclaturalAuthorTeamSelectionElement;
 
 /**
@@ -38,10 +37,10 @@ public class AuthorshipDetailElement extends
 	AbstractIdentifiableEntityDetailElement<NonViralName> implements
 		IEnableableFormElement {
 
-	private AbstractSelectionElement selection_exBasionymAuthorTeam;
-	private AbstractSelectionElement selection_basionymAuthorTeam;
-	private AbstractSelectionElement selection_exCombinationAuthorTeam;
-	private AbstractSelectionElement selection_combinationAuthorTeam;
+	private NomenclaturalAuthorTeamSelectionElement selection_exBasionymAuthorTeam;
+	private NomenclaturalAuthorTeamSelectionElement selection_basionymAuthorTeam;
+	private NomenclaturalAuthorTeamSelectionElement selection_exCombinationAuthorTeam;
+	private NomenclaturalAuthorTeamSelectionElement selection_combinationAuthorTeam;
 
 	/**
 	 * <p>
@@ -69,30 +68,29 @@ public class AuthorshipDetailElement extends
 		toggleable_cache = formFactory.createToggleableTextField(this,
 				"Authorship Cache", entity.getAuthorshipCache(),
 				entity.isProtectedAuthorshipCache(), style);
-
-		selection_combinationAuthorTeam = formFactory.createSelectionElement(
-				SelectionType.AUTHOR_TEAM, getConversationHolder(),
+		selection_combinationAuthorTeam = formFactory.createNomenclaturalAuthorTeamSelectionElement(
+				getConversationHolder(),
 				formElement, "Author",
 				AuthorHelper.getAuthor(entity.getCombinationAuthorTeam()),
-				NomenclaturalAuthorTeamSelectionElement.DEFAULT, style);
+				EntitySelectionElement.ALL, style);
 		addElement(selection_combinationAuthorTeam);
-		selection_exCombinationAuthorTeam = formFactory.createSelectionElement(
-				SelectionType.AUTHOR_TEAM, getConversationHolder(),
+		selection_exCombinationAuthorTeam = formFactory.createNomenclaturalAuthorTeamSelectionElement(
+				getConversationHolder(),
 				formElement, "Ex Author",
 				AuthorHelper.getAuthor(entity.getExCombinationAuthorTeam()),
-				NomenclaturalAuthorTeamSelectionElement.DEFAULT, style);
+				EntitySelectionElement.ALL, style);
 		addElement(selection_exCombinationAuthorTeam);
-		selection_basionymAuthorTeam = formFactory.createSelectionElement(
-				SelectionType.AUTHOR_TEAM, getConversationHolder(),
+		selection_basionymAuthorTeam = formFactory.createNomenclaturalAuthorTeamSelectionElement(
+				getConversationHolder(),
 				formElement, "Basionym Author",
 				AuthorHelper.getAuthor(entity.getBasionymAuthorTeam()),
-				NomenclaturalAuthorTeamSelectionElement.DEFAULT, style);
+				EntitySelectionElement.ALL, style);
 		addElement(selection_basionymAuthorTeam);
-		selection_exBasionymAuthorTeam = formFactory.createSelectionElement(
-				SelectionType.AUTHOR_TEAM, getConversationHolder(),
+		selection_exBasionymAuthorTeam = formFactory.createNomenclaturalAuthorTeamSelectionElement(
+				getConversationHolder(),
 				formElement, "Ex Basionym Author",
 				AuthorHelper.getAuthor(entity.getExBasionymAuthorTeam()),
-				NomenclaturalAuthorTeamSelectionElement.DEFAULT, style);
+				EntitySelectionElement.ALL, style);
 		addElement(selection_exBasionymAuthorTeam);
 	}
 
@@ -102,8 +100,7 @@ public class AuthorshipDetailElement extends
 		if (getEntity() == null) {
 			setEntity(NonViralName.NewInstance(null));
 		}
-		NonViralName nonViralName = getEntity();
-
+		
 		super.updateContent();
 		toggleable_cache.setEnabled(getEntity().isProtectedAuthorshipCache());
 
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/HybridDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/HybridDetailElement.java
index 8e93610b2..1dfab3c0f 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/HybridDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/HybridDetailElement.java
@@ -12,7 +12,6 @@ package eu.etaxonomy.taxeditor.ui.section.name;
 
 import eu.etaxonomy.cdm.model.name.NonViralName;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
-import eu.etaxonomy.taxeditor.ui.element.CdmPropertyChangeEvent;
 import eu.etaxonomy.taxeditor.ui.element.CheckboxElement;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/NameRelationshipDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/NameRelationshipDetailElement.java
index a34670ed0..c0e1988f1 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/NameRelationshipDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/NameRelationshipDetailElement.java
@@ -24,7 +24,7 @@ import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.LabelElement;
 import eu.etaxonomy.taxeditor.ui.element.TextWithLabelElement;
 import eu.etaxonomy.taxeditor.ui.section.supplemental.AbstractReferencedEntityElement;
-import eu.etaxonomy.taxeditor.ui.selection.AbstractSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 
 /**
  * <p>NameRelationshipDetailElement class.</p>
@@ -36,7 +36,7 @@ import eu.etaxonomy.taxeditor.ui.selection.AbstractSelectionElement;
 public class NameRelationshipDetailElement extends AbstractReferencedEntityElement<NameRelationship>{
 
 	private TextWithLabelElement text_ruleConsidered;
-	private AbstractSelectionElement selection_toName;
+	private EntitySelectionElement selection_toName;
 	private TermComboElement<NameRelationshipType> combo_relationshipType;
 	private LabelElement label;
 
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/NameRelationshipWizard.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/NameRelationshipWizard.java
index ba2cd2922..e7abd5666 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/NameRelationshipWizard.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/NameRelationshipWizard.java
@@ -10,7 +10,6 @@
 
 package eu.etaxonomy.taxeditor.ui.section.name;
 
-import org.apache.log4j.Logger;
 import org.eclipse.jface.wizard.Wizard;
 
 import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
@@ -35,12 +34,9 @@ public class NameRelationshipWizard extends Wizard implements IConversationEnabl
 	 * @param callingSection a {@link eu.etaxonomy.taxeditor.ui.section.name.NameRelationshipDetailSection} object.
 	 */
 	public NameRelationshipWizard(NameRelationshipDetailSection callingSection) {
-		this.callingSection = callingSection;
+		NameRelationshipWizard.callingSection = callingSection;
 	}
-	
-	private static final Logger logger = Logger
-			.getLogger(NameRelationshipWizard.class);
-	
+		
 	private NameRelationshipWizardPage page;
 
 	/** {@inheritDoc} */
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/NameRelationshipWizardPage.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/NameRelationshipWizardPage.java
index 083ee7686..162626a04 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/NameRelationshipWizardPage.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/NameRelationshipWizardPage.java
@@ -21,9 +21,9 @@ import eu.etaxonomy.cdm.model.name.NameRelationshipType;
 import eu.etaxonomy.cdm.model.name.TaxonNameBase;
 import eu.etaxonomy.taxeditor.ui.combo.TermComboElement;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
+import eu.etaxonomy.taxeditor.ui.element.LayoutConstants;
 import eu.etaxonomy.taxeditor.ui.element.RootElement;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.SelectionType;
-import eu.etaxonomy.taxeditor.ui.selection.NameSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 
 /**
  * <p>
@@ -39,12 +39,10 @@ public class NameRelationshipWizardPage extends WizardPage implements
 
 	private final CdmFormFactory formFactory;
 
-	private NameSelectionElement selection_relatedTo;
+	private EntitySelectionElement<TaxonNameBase> selection_relatedTo;
 
 	private TermComboElement<NameRelationshipType> combo_relationshipType;
 
-	private final NameRelationshipDetailSection callingSection;
-
 	private final TaxonNameBase entity;
 
 	private NameRelationshipType type;
@@ -68,7 +66,6 @@ public class NameRelationshipWizardPage extends WizardPage implements
 		super("NameRelationshipWizardPage");
 		setTitle("New Name Relationship");
 		setDescription(callingSection.getEntity().getTitleCache());
-		this.callingSection = callingSection;
 		this.entity = callingSection.getEntity();
 		this.formFactory = callingSection.getFormFactory();
 
@@ -89,18 +86,18 @@ public class NameRelationshipWizardPage extends WizardPage implements
 
 		Composite control = formFactory.createComposite(parent);
 
-		control.setLayout(CdmFormFactory.LAYOUT(2, false));
+		control.setLayout(LayoutConstants.LAYOUT(2, false));
 
 		rootElement = new RootElement(formFactory, control);
 
 		combo_relationshipType = formFactory.createTermComboElement(NameRelationshipType.class,
 						rootElement, "Name Relationship Type", null, SWT.NULL);
 
-		selection_relatedTo = (NameSelectionElement) formFactory
-				.createSelectionElement(SelectionType.NAME,
+		selection_relatedTo = formFactory
+				.createSelectionElement(TaxonNameBase.class,
 						((NameRelationshipWizard) getWizard())
 								.getConversationHolder(), rootElement,
-						"Related to", null, NameSelectionElement.DEFAULT,
+						"Related to", null, EntitySelectionElement.ALL,
 						SWT.NULL);
 
 		setControl(control);
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/NameTypeDesignationElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/NameTypeDesignationElement.java
index 3ef47abb6..6d4c33854 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/NameTypeDesignationElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/NameTypeDesignationElement.java
@@ -21,8 +21,7 @@ import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.CheckboxElement;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.SelectionType;
-import eu.etaxonomy.taxeditor.ui.selection.NameSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 
 /**
  * <p>
@@ -38,7 +37,7 @@ public class NameTypeDesignationElement extends
 
 	private CheckboxElement checkbox_rejectedType;
 	private CheckboxElement checkbox_conservedType;
-	private NameSelectionElement selection_typeName;
+	private EntitySelectionElement<TaxonNameBase> selection_typeName;
 	private TermComboElement<NameTypeDesignationStatus> combo_typeStatus;
 
 	/**
@@ -74,10 +73,10 @@ public class NameTypeDesignationElement extends
 				"Rejected Type", false, style);
 		checkbox_conservedType = formFactory.createCheckbox(formElement,
 				"Conserved Type", false, style);
-		selection_typeName = (NameSelectionElement) formFactory
-				.createSelectionElement(SelectionType.NAME,
+		selection_typeName = formFactory
+				.createSelectionElement(TaxonNameBase.class,
 						getConversationHolder(), formElement, "Name", null,
-						NameSelectionElement.DEFAULT, style);
+						EntitySelectionElement.ALL, style);
 		combo_typeStatus = formFactory.createTermComboElement(
 				NameTypeDesignationStatus.class, formElement,
 						"Designation Status", null, style);
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/NonViralNameDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/NonViralNameDetailElement.java
index 3c8ea2405..55662b2d5 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/NonViralNameDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/NonViralNameDetailElement.java
@@ -20,6 +20,7 @@ import eu.etaxonomy.taxeditor.ui.combo.EnumComboElement;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.DetailType;
+import eu.etaxonomy.taxeditor.ui.element.LayoutConstants;
 import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection;
 import eu.etaxonomy.taxeditor.ui.section.AbstractIdentifiableEntityDetailElement;
 
@@ -82,21 +83,21 @@ public class NonViralNameDetailElement extends
 		section_name = (NameDetailSection) formFactory.createCdmDetailSection(
 				DetailType.SCIENTIFICNAME, getConversationHolder(),
 				formElement, null, Section.TWISTIE | Section.EXPANDED);
-		section_name.setLayoutData(CdmFormFactory.FILL_HORIZONTALLY(2, 1));
+		section_name.setLayoutData(LayoutConstants.FILL_HORIZONTALLY(2, 1));
 		addControl(section_name);
 		addElement(section_name);
 		section_author = (AuthorshipDetailSection) formFactory
 				.createCdmDetailSection(DetailType.AUTHORSHIP,
 						getConversationHolder(), formElement, null,
 						Section.TWISTIE | Section.EXPANDED);
-		section_author.setLayoutData(CdmFormFactory.FILL_HORIZONTALLY(2, 1));
+		section_author.setLayoutData(LayoutConstants.FILL_HORIZONTALLY(2, 1));
 		addControl(section_author);
 		addElement(section_author);
 		
 		section_hybrid = (HybridDetailSection) formFactory.createCdmDetailSection(DetailType.HYBRID, 
 						getConversationHolder(), formElement, null, 
 						Section.TWISTIE);
-		section_hybrid.setLayoutData(CdmFormFactory.FILL_HORIZONTALLY(2, 1));
+		section_hybrid.setLayoutData(LayoutConstants.FILL_HORIZONTALLY(2, 1));
 		addControl(section_hybrid);
 		addElement(section_hybrid);
 	}
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/NonViralNameWizardPage.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/NonViralNameWizardPage.java
index b1fead904..4603f031d 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/NonViralNameWizardPage.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/NonViralNameWizardPage.java
@@ -10,15 +10,14 @@
 
 package eu.etaxonomy.taxeditor.ui.section.name;
 
-import org.apache.log4j.Logger;
 import org.eclipse.swt.SWT;
 
 import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
 import eu.etaxonomy.cdm.model.name.NonViralName;
 import eu.etaxonomy.taxeditor.ui.element.AbstractCdmEntityWizardPage;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
-import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.DetailType;
+import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
 
 /**
@@ -30,9 +29,6 @@ import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
  */
 public class NonViralNameWizardPage extends AbstractCdmEntityWizardPage<NonViralName> {
 
-
-	private static final Logger logger = Logger
-			.getLogger(NonViralNameWizardPage.class);
 	private NonViralNameDetailElement nameElement;
 
 	/**
@@ -50,7 +46,7 @@ public class NonViralNameWizardPage extends AbstractCdmEntityWizardPage<NonViral
 	
 	/** {@inheritDoc} */
 	@Override
-	public AbstractCdmDetailElement createElement(ICdmFormElement rootElement) {
+	public AbstractCdmDetailElement<NonViralName> createElement(ICdmFormElement rootElement) {
 		nameElement = (NonViralNameDetailElement) formFactory.createCdmDetailElement(DetailType.NONVIRALNAME, rootElement, SWT.NULL);
 		nameElement.setEntity(entity);
 		return nameElement;
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/ProtologueElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/ProtologueElement.java
index d8292ee3a..ed29e2f45 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/ProtologueElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/ProtologueElement.java
@@ -31,7 +31,6 @@ import eu.etaxonomy.taxeditor.ui.element.ISelectableElement;
 import eu.etaxonomy.taxeditor.ui.element.SelectionArbitrator;
 import eu.etaxonomy.taxeditor.ui.element.TextWithLabelElement;
 import eu.etaxonomy.taxeditor.ui.openurl.IOpenUrlEnabled;
-import eu.etaxonomy.taxeditor.ui.openurl.OpenUrlSelectorElement;
 import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement;
 
 /**
@@ -50,8 +49,6 @@ public class ProtologueElement extends AbstractEntityCollectionElement<Descripti
 	private Media media;
 	private MediaRepresentation mediaRepresentation;
 
-	private OpenUrlSelectorElement element_openUrl;
-
 	/**
 	 * <p>Constructor for ProtologueElement.</p>
 	 *
@@ -75,7 +72,7 @@ public class ProtologueElement extends AbstractEntityCollectionElement<Descripti
 	public void createControls(ICdmFormElement element, int style) {
 		protologueUriText = formFactory.createTextWithLabelElement(this, "Protologue URI", "", style);
 
-		element_openUrl = formFactory.createOpenUrlSelectorElement(element, "Query BHL for Reference Image", this, style);
+		formFactory.createOpenUrlSelectorElement(element, "Query BHL for Reference Image", this, style);
 	}
 
 	/* (non-Javadoc)
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/SpecimenTypeDesignationElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/SpecimenTypeDesignationElement.java
index edbf00b8d..1fd7f9a17 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/SpecimenTypeDesignationElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/name/SpecimenTypeDesignationElement.java
@@ -15,14 +15,14 @@ import org.eclipse.swt.events.SelectionListener;
 import eu.etaxonomy.cdm.hibernate.HibernateProxyHelper;
 import eu.etaxonomy.cdm.model.name.SpecimenTypeDesignation;
 import eu.etaxonomy.cdm.model.name.SpecimenTypeDesignationStatus;
+import eu.etaxonomy.cdm.model.occurrence.DerivedUnitBase;
 import eu.etaxonomy.cdm.model.occurrence.Specimen;
 import eu.etaxonomy.taxeditor.ui.combo.TermComboElement;
 import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.TextWithLabelElement;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.SelectionType;
-import eu.etaxonomy.taxeditor.ui.selection.DerivedUnitBaseSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 
 /**
  * <p>
@@ -37,7 +37,7 @@ public class SpecimenTypeDesignationElement extends
 		AbstractTypeDesignationElement<SpecimenTypeDesignation> {
 
 	private TermComboElement<SpecimenTypeDesignationStatus> combo_typeStatus;
-	private DerivedUnitBaseSelectionElement selection_typeSpecimen;
+	private EntitySelectionElement<DerivedUnitBase> selection_typeSpecimen;
 	private TextWithLabelElement text_specimenTypeText;
 
 	/**
@@ -68,10 +68,10 @@ public class SpecimenTypeDesignationElement extends
 	/** {@inheritDoc} */
 	@Override
 	public void createControls(ICdmFormElement formElement, int style) {
-		selection_typeSpecimen = (DerivedUnitBaseSelectionElement) formFactory
-				.createSelectionElement(SelectionType.DERIVED_UNIT,
+		selection_typeSpecimen = formFactory
+				.createSelectionElement(DerivedUnitBase.class,
 						getConversationHolder(), formElement, "Specimen", null,
-						DerivedUnitBaseSelectionElement.DEFAULT, style);
+						EntitySelectionElement.ALL, style);
 		combo_typeStatus = formFactory
 				.createTermComboElement(SpecimenTypeDesignationStatus.class,
 						formElement, "Designation Status", null, style);
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/AbstractEventDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/AbstractEventDetailElement.java
index 6179ea83b..589764a84 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/AbstractEventDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/AbstractEventDetailElement.java
@@ -12,15 +12,15 @@ package eu.etaxonomy.taxeditor.ui.section.occurrence;
 
 import org.eclipse.swt.events.SelectionListener;
 
+import eu.etaxonomy.cdm.model.agent.AgentBase;
 import eu.etaxonomy.cdm.model.common.EventBase;
 import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.TextWithLabelElement;
 import eu.etaxonomy.taxeditor.ui.element.TimePeriodElement;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.SelectionType;
 import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement;
-import eu.etaxonomy.taxeditor.ui.selection.AgentSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 
 /**
  * <p>
@@ -34,7 +34,7 @@ import eu.etaxonomy.taxeditor.ui.selection.AgentSelectionElement;
 public abstract class AbstractEventDetailElement<T extends EventBase> extends
 		AbstractEntityCollectionElement<T> {
 
-	protected AgentSelectionElement selection_agent;
+	protected EntitySelectionElement<AgentBase> selection_agent;
 	protected TextWithLabelElement text_description;
 	protected TimePeriodElement element_timePeriod;
 
@@ -89,10 +89,10 @@ public abstract class AbstractEventDetailElement<T extends EventBase> extends
 	/** {@inheritDoc} */
 	@Override
 	public void createControls(ICdmFormElement element, int style) {
-		selection_agent = (AgentSelectionElement) formFactory
-				.createSelectionElement(SelectionType.AGENT,
+		selection_agent = formFactory
+				.createSelectionElement(AgentBase.class,
 						getConversationHolder(), element, "Actor", null,
-						AgentSelectionElement.DEFAULT, style);
+						EntitySelectionElement.ALL, style);
 		element_timePeriod = formFactory.createTimePeriodElement(element,
 				"Time Period", null, style);
 		text_description = formFactory.createTextWithLabelElement(element,
